% gda03_10
%
% constrained least squares fit to synthetic data

% z's
N=30;
zmin=0;
zmax=10;
z = sort(random('Uniform',zmin,zmax,N,1));

% d = a + b*z + noise
a=2.0;
b=1.0;
sd=0.5;
dobs = a+b*z+random('Normal',0,sd,N,1);

% constraint
zp = 8;
dp = 6;

% constrained least squares fit
M=2;
G=[ones(N,1), z];
F = [1, zp];
A = [ [G'*G, F']', [F, 0]' ];
b = [ [G'*dobs]', dp ]';
mest = A\b;

% predicted data
dpre = G*mest(1:M);
e = dobs - dpre;
[emax, iemax] = max(abs(e));

% plot
figure(1);
clf;

pdmin=0;
pdmax=15;

set(gca,'LineWidth',2);
hold on;
axis( [zmin, zmax, pdmin, pdmax ]' );
plot( z, dobs, 'ro', 'LineWidth', 2);
plot( zp, dp, 'bo', 'LineWidth', 4);
plot( z, dpre, 'b-', 'LineWidth', 2);
xlabel('z');
ylabel('d');

